/*
 * mouse.c
 *
 *  Created on: 29.05.2012
 *      Author: sme
 */

#include "mouse.h"

extern void init_mouse(void){

	uart_init();



}
void uart_init(void)
{
  uart_flush();
  UBRR0H = UBRR_VAL >> 8;
  UBRR0L = UBRR_VAL & 0xFF;

  UCSR0B = (1<<RXEN0) | (1<<RXCIE0) | (1<<RXCIE0);  // UART RX einschalten RX interrupt an
  UCSR0C = (1<<UCSZ01);  // Asynchron 7N1

  sei();
  mouse_rx_pointer = 0;
  mouse_rx_status = WAITING_FOR_FIRST_BYTE;
}


void uart_flush( void )
{
	uint8_t dummy;
	while ( UCSR0A & (1<<RXC0) ) dummy = UDR0;
}

ISR(USART_RX_vect){

	uint8_t rxd_char = UDR0;//Byten aus dem puffer abhohlen.

	if (rxd_char & 0b01000000){//Wenn das empfange byte das SYNC byte ist
		mouse_rx_buffer[0] = rxd_char;
		mouse_rx_status = WAITING_FOR_SECOND_BYTE;
	}
	else if (mouse_rx_status == WAITING_FOR_SECOND_BYTE){
		mouse_rx_buffer[1] = rxd_char;
		mouse_rx_status = WAITING_FOR_THIRD_BYTE;

	}
	else if (mouse_rx_status == WAITING_FOR_THIRD_BYTE){
			mouse_rx_buffer[2] = rxd_char;
			mouse_rx_status = FRAME_COMPLETE;
	}






	if(mouse_rx_status == FRAME_COMPLETE){

		mouse_x = (((mouse_rx_buffer[0] & 0b00000011) << 6) | (mouse_rx_buffer[1] & 0b00111111));
		mouse_y = (((mouse_rx_buffer[0] & 0b00001100) << 4) | (mouse_rx_buffer[2] & 0b00111111));

		if (mouse_x > 3){//Bewegung nach Rechts
			send_note_on(0x10, (mouse_x & 0b01111111));
		}else if(mouse_x < -3){//Bewegung nach Links
			send_note_on(0x11, (mouse_x & 0b01111111));
		}

		if (mouse_y > 3){//Bewegung nach Unten
			send_note_on(0x12, (mouse_y & 0b01111111));
		}else if(mouse_y < -3){//Bewegung nach Oben
			send_note_on(0x13, (mouse_y & 0b01111111));
		}
		mouse_rx_status = WAITING_FOR_FIRST_BYTE;
	}


}
