/*
 * mouse.h
 *
 *  Created on: 29.05.2012
 *      Author: sme
 */

#ifndef MOUSE_H_
#define MOUSE_H_

#include <avr/io.h>
#include <avr/interrupt.h>
#include "usb.h"

extern void init_mouse(void);

#define BAUD 1200UL
// Berechnungen
#define UBRR_VAL ((F_CPU+BAUD*8)/(BAUD*16)-1)   // clever runden
#define BAUD_REAL (F_CPU/(16*(UBRR_VAL+1)))     // Reale Baudrate
#define BAUD_ERROR ((BAUD_REAL*1000)/BAUD) // Fehler in Promille, 1000 = kein Fehler.


extern void uart_init(void);
extern void uart_flush( void );

enum  {FRAME_COMPLETE ,WAITING_FOR_FIRST_BYTE, WAITING_FOR_SECOND_BYTE, WAITING_FOR_THIRD_BYTE};

volatile uint8_t mouse_rx_status;
volatile uint8_t mouse_rx_buffer[3];
volatile uint8_t mouse_rx_pointer;
volatile int8_t mouse_x;
volatile int8_t mouse_y;

#endif /* MOUSE_H_ */
